import "Turbine"
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "JackdawPlugins.Sutt.class"
NewQuickslot=JackdawPlugins.Sutt.NewQuickslot

--Load here
local Load=Turbine.PluginData.Load( Turbine.DataScope.Character, "SuttQuickslots" )
if Load==nil then
	shortcut={}
	x=100
	y=100
	icx=4
	icy=3
	Scale=1
	SBX=100
	SBY=100
	new=true
else
	shortcut=Load[1]
	x=Load[2]
	y=Load[3]
	icx=Load[4]
	icy=Load[5]
	Scale=Load[6]
	SBX=Load[7]
	SBY=Load[8]
end

size=36
pad={top=30,side=15,bottom=15}

width=size*icx+2*pad.side
height=size*icy+pad.top+pad.bottom

Sutt=Turbine.UI.Control()

Sutt.Window = Turbine.UI.Lotro.GoldWindow()
	Sutt.Window:SetPosition( x,y )
	Sutt.Window:SetSize(width,height)
	if new then Sutt.Window:SetVisible(true) Turbine.Shell.WriteLine("Welcome to Sutt Quickslots. Click the button (at the top left currently) to hide/show the bar.") end
	Sutt.Window:SetText("Sutt Slots")

Sutt.ListBox = Turbine.UI.ListBox()
	Sutt.ListBox:SetParent( Sutt.Window )
	Sutt.ListBox:SetPosition( pad.side, pad.top )
	Sutt.ListBox:SetSize( icx*size, icy*size)
	Sutt.ListBox:SetMaxItemsPerLine(icx)
	Sutt.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
	
	Sutt.Resize=Turbine.UI.Control()
		Sutt.Resize:SetParent(Sutt.Window)
		Sutt.Resize:SetZOrder(99)
		Sutt.Resize:SetSize(10,10)
		Sutt.Resize:SetPosition(width-10,height-10)
		
		Sutt.ResizeBack=Turbine.UI.Control()
		Sutt.ResizeBack:SetParent(Sutt.Resize)
		Sutt.ResizeBack:SetSize(10,10)
		Sutt.ResizeBack:SetBackColor(Turbine.UI.Color(1,1,1,1))
		Sutt.ResizeBack:SetVisible(false)
		Sutt.ResizeBack:SetMouseVisible(false)
		
		Sutt.Resize.MouseEnter=function() Sutt.ResizeBack:SetVisible(true) end
		Sutt.Resize.MouseLeave=function() Sutt.ResizeBack:SetVisible(false)  end
		
		Sutt.Resize.MouseDown=function ()
			draggingr=true
		end
		Sutt.Resize.MouseUp=function ()
			draggingr=false
		end
		Sutt.Resize.MouseMove=function()
			if draggingr then
					width,height=Sutt.Window:GetMousePosition()
					icx=math.floor((width-2*pad.side)/size)
					icy=math.floor((height-(pad.top+pad.bottom))/size)
					if icx<3 then icx=3 end
					if icy<1 then icy=1 end
					width=size*icx+2*pad.side
					height=size*icy+pad.top+pad.bottom
					Sutt.Window:SetSize(width,height)
					Sutt.ListBox:SetSize( size*icx, size*icy)
					Sutt.ListBox:SetMaxItemsPerLine(icx)
					Sutt.Resize:SetPosition(width-10,height-10)
					if icx*icy>#Sutt.Quickslots then
						for i=#Sutt.Quickslots+1,icx*icy do
							Sutt.Quickslots[i]=NewQuickslot()
							Sutt.ListBox:AddItem(Sutt.Quickslots[i])
						end
					end
			end
		end

--Good old PSetShortcut. Stops those nasty errors...
function PSetShortcut(target,source)
	pcall(function () target:SetShortcut(source) end)
end

import "Deusdictum.UI.Dragbar"

SuttButton={}
	SuttButton.Window=Turbine.UI.Window()
	SuttButton.Window:SetVisible(true)
	SuttButton.Window.DragBar = Deusdictum.UI.DragBar( SuttButton.Window,"Sutt")
	SuttButton.Window:SetPosition(SBX,SBY)
	SuttButton.Window:SetSize(32,32)
	SuttButton.Window:SetOpacity(1)
	SuttButton.Window:SetMouseVisible(true)
	SuttButton.Window:SetBackground(0x410080a7)
	SuttButton.Window:SetStretchMode(1)
	SuttButton.Window:SetSize(32*Scale,32*Scale)
		
	function SuttButton.Window:GetWidth()
		return 32*Scale
	end
	function SuttButton.Window:GetHeight()
		return 32*Scale
	end
	function SuttButton.Window:GetSize()
		return 32*Scale ,32*Scale
	end
	
	SuttButton.Window.DragBar:Refresh()
	
	SuttButton.Window.MouseDown=function(sender,args)
		if SuttButton.Window.DragBar:IsVisible() then
			moving=true
		else
			if ( args.Button == Turbine.UI.MouseButton.Left ) then
				Sutt.Window:SetVisible(not(Sutt.Window:IsVisible()))
			end
		end	
	end
	SuttButton.Window.MouseUp=function(sender,args)
		moving=false
	end
	SuttButton.Window.MouseMove=function(sender,args)
			if moving then
			local x,y=SuttButton.Window:GetMousePosition()

			Scale=math.max(x,y)/32
			if Scale<0.25 then Scale=0.25 end

			SuttButton.Window:SetSize(32*Scale,32*Scale)
			SuttButton.Window.DragBar:Refresh()
		end
	end


Sutt.Quickslots={}
	for i=1,icx*icy do
		Sutt.Quickslots[i]=NewQuickslot()
		if shortcut[i]~=nil then PSetShortcut(Sutt.Quickslots[i],Turbine.UI.Lotro.Shortcut( shortcut[i].Type,shortcut[i].Data )) end
		Sutt.ListBox:AddItem(Sutt.Quickslots[i])
	end

--Save the settings!
Plugins["SuttQuickslots"].Unload = function( sender, args )
				for j=1,#Sutt.Quickslots do
					local sc=Sutt.Quickslots[j]:GetShortcut()
					shortcut[j]={}
					shortcut[j].Data=sc:GetData()
					shortcut[j].Type=sc:GetType()
				end
	x,y=Sutt.Window:GetPosition()
	SBX,SBY=SuttButton.Window:GetPosition()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "SuttQuickslots", {shortcut,x,y,icx,icy,Scale,SBX,SBY} )
end	
	